var tooltip_divName = 'tooltip-popup'; // class name of div to follow mouse
var tooltip_offX = 15; // X offset from mouse position
var tooltip_offY = 15; // Y offset from mouse position
var tooltip_div = undefined;

function tooltip_create() {
	// Create a new div and attach to document
	tooltip_div = document.createElement("div");
	document.body.appendChild(tooltip_div);
	tooltip_div.className = "tooltip-popup";
	tooltip_div.style.position = "absolute";
	tooltip_div.style.visibility = "hidden";
    tooltip_div.style.backgroundColor = "#505050";
    tooltip_div.style.border = "2px solid black";
    tooltip_div.style.color = "white";
    tooltip_div.style.opacity = "0.8";
}

function tooltip_showIt(htmlContent) {
	if(!tooltip_div) {
		tooltip_create();
	}
	tooltip_setContent(htmlContent);
	tooltip_div.style.visibility = 'visible';
	document.onmousemove = tooltip_follow;
}

function tooltip_hide() {
	if(!tooltip_div) {
		tooltip_create();
	}
	tooltip_div.style.visibility = 'hidden';
	document.onmousemove = null;
}

function tooltip_setContent(htmlContent) {
	if(!tooltip_div) {
		tooltip_create();
	}
	tooltip_div.innerHTML = htmlContent;
}

function tooltip_mouseX(evt) {
	if (!evt)
		evt = window.event;
	if (evt.pageX)
		return evt.pageX;
	else if (evt.clientX)
		return evt.clientX + (document.documentElement.scrollLeft
				? document.documentElement.scrollLeft
				: document.body.scrollLeft);
	else
		return 0;
}

function tooltip_mouseY(evt) {
	if (!evt)
		evt = window.event;
	if (evt.pageY)
		return evt.pageY;
	else if (evt.clientY)
		return evt.clientY + (document.documentElement.scrollTop
				? document.documentElement.scrollTop
				: document.body.scrollTop);
	else
		return 0;
}

function tooltip_follow(evt) {
	if (tooltip_div) {
		tooltip_div.style.left = (parseInt(tooltip_mouseX(evt)) + tooltip_offX) + 'px';
		tooltip_div.style.top = (parseInt(tooltip_mouseY(evt)) + tooltip_offY) + 'px';
	}
}