$(document).ready(function() {
    // On duration/percent field change.
    $("#massUpdate2NewValue").change(function() {

        var value = $(this).val();

        if (TW.isIncDecPercentOperation()) {
            if (isNaN(value) ||
                !(      (TW.isDecreasePercentChange() && (+value > 0) && (+value < 100))
                     || (TW.isIncreasePercentChange() && (+value > 0)                 ))) {
                value = null;
            }
        } else {
            value = TW.durationObjectToString(TW.parseDurationFromUserInput(value));
        } 

        if (value) {
            $(this).removeClass("error");
            $(this).val(value);
        } else {
            $(this).addClass("error");
        }
        
    });

    // On due date field changed.
    $("#massUpdate2NewDueDateSpan :text").change(function() {
        var date = TW.checkDueDate($(this).val());
        if (date) {
            $(this).val(date);
            $(this).removeClass("error");
        } else {
            $(this).addClass("error");
        }
    });

    // On "Update Value" button click.
    $("button#massUpdate2UpdateValue").click(function() {
        // Validate drop-downs
        $("#massUpdates2 select").removeClass("error").filter(":visible").each(function() {
            if (!$(this).val()) {
                $(this).addClass("error");
            }
        });

        // Initiate validation on visible input fields.
        if ($("#massUpdate2NewValue").is(":visible") && $("#massUpdate2NewValue").parent().is(":visible")) {
            $("#massUpdate2NewValue").change();
        }
        
        if ($("#massUpdate2NewDueDateSpan").is(":visible") && $("#massUpdate2NewDueDateSpan").parent().is(":visible")) {
            $("#massUpdate2NewDueDateSpan :text").change();
        }

        // Ignore table errors for set and reset. 
        if ( (TW.isSetResetValueOperation() && !TW.hasErrors("#massUpdates2 select:visible")) || !TW.hasErrors()) {
            TW.massUpdate();
        }
        
    });

    // On change type.
    $("#massUpdate2ChangeType").change(function() {
        $("#massUpdate2ChangeWhat").hide();
        $("#massUpdates2NewValueSpan").hide();
        $("#massUpdate2NewValuePercentSymbol").hide();

        $("select#massUpdate2ApplyToWhat").restoreOptions();
        $("select#massUpdate2ChangeWhat").restoreOptions();

        
        switch ($(this).val()) {
            case "resetToCurrent":
                    $("#massUpdate2ChangeWhat").show();
                    $("select#massUpdate2ApplyToWhat").hideOption("unchanged");
                    $("select#massUpdate2ApplyToWhat").hideOption("all");
                break;
            case "setValue":
                $("#massUpdate2ChangeWhat").show();
                $("#massUpdates2NewValueSpan").show();
                break;
            case "decreaseAmount":
            case "increaseAmount":
                    $("select#massUpdate2ChangeWhat").hideOption("priority");
                    $("#massUpdate2ChangeWhat").show();
                    $("#massUpdates2NewValueSpan").show();
                break;
            case "increasePercent":
            case "decreasePercent":
                    $("#massUpdates2NewValueSpan").show();
                    $("#massUpdate2NewValuePercentSymbol").show();
                break;
            default:
        }
        
        $("#massUpdate2ChangeWhat").val("");
        $("#massUpdate2ChangeWhat").change();
    });

    // On change change what.
    $("#massUpdate2ChangeWhat").change(function() {

        $("#massUpdates2 :text").removeClass("error");
        
        if (TW.isIncDecPercentOperation()) {
            $("#massUpdate2ApplyToType").hide();
        } else {
            $("#massUpdate2ApplyToType").show();
        }
        
        $("#massUpdate2Priorities").hide();
        $("#massUpdate2NewValue").hide();
        $("#massUpdate2NewDueDateSpan").hide();
        
        switch($(this).val()) {
            case "duration":
                $("#massUpdate2NewValue").show();
                $("#massUpdate2ApplyToType").hide();
                break;
            case "dueDate":
                if (TW.isIncDecAmountOperation()) {
                    $("#massUpdate2NewValue").show();
                } else {
                    $("#massUpdate2NewDueDateSpan").show();
                }
                break;
            case "priority":
                $("#massUpdate2Priorities").show();
                break;
            default:
        }
        
        if (TW.isIncDecPercentOperation()) {
            $("#massUpdate2NewValue").show();
        }

    });
});

TW.isIncDecPercentOperation = function() {
    return     $("#massUpdate2ChangeType").val() === "increasePercent"
            || $("#massUpdate2ChangeType").val() === "decreasePercent";
};

TW.isIncDecAmountOperation = function() {
    return     $("#massUpdate2ChangeType").val() === "increaseAmount"
            || $("#massUpdate2ChangeType").val() === "decreaseAmount";
};

TW.isDecreaseAmountOperation = function() {
    return $("#massUpdate2ChangeType").val() === "decreaseAmount";
};

TW.isIncreaseAmountOperation = function() {
    return $("#massUpdate2ChangeType").val() === "increaseAmount";
};


TW.isSetResetValueOperation = function() {
    return     $("#massUpdate2ChangeType").val() === "setValue"
            || $("#massUpdate2ChangeType").val() === "resetToCurrent";
};

TW.isDueDateChange = function() {
    return $("#massUpdate2ChangeWhat").val() === "dueDate";
};

TW.isDurationChange = function() {
    return $("#massUpdate2ChangeWhat").val() === "duration";
};

TW.isDecreasePercentChange = function() {
    return $("#massUpdate2ChangeType").val() === "decreasePercent";
};

TW.isIncreasePercentChange = function() {
    return $("#massUpdate2ChangeType").val() === "increasePercent";
};

TW.isResetValueOperation = function() {
    return $("#massUpdate2ChangeType").val() === "resetToCurrent";
};


TW.massUpdate = function() {
    TW.pageData.massUpdate = true;
    TW.pageData.loadingDialog.show();

    if (TW.isIncDecPercentOperation()) {
        $("#massUpdate2ChangeWhat").val("duration");
        $("#massUpdate2ApplyToType").val("activities");
    }
    
    if ( TW.isIncDecAmountOperation() && TW.isDurationChange()) {
        $("#massUpdate2ApplyToType").val("activities");
    }
    
    if (TW.isSetResetValueOperation() && TW.isDurationChange()) {  
        $("#massUpdate2ApplyToType").val("activities");
    }
    
    // Row filtering stage #1. Filter visible rows, filter by type.
    var trs = $("tbody#dueDatesContent").children()
            .not(".completed")
            .filter(":visible")
            .filter(TW.massUpdateMap[$("#massUpdate2ApplyToType").val()]);

    // Row filtering stage #2. Filter critical if #massUpdateApplyToType is critical.
    if ($("#massUpdate2ApplyToWhat").val() == "criticalPath") {
        trs = trs.filter(".critical");
    }    

    // Input filtering stage #1. Find input and select controls of specified type.
    var inputs = $(trs).find("td." + $("#massUpdate2ChangeWhat").val()).find(":text, select");

    // Input filtering stage #2. Filter changed or not changed inputs if not filtering critical.
    // Rest to Current has additional modifier for criticalPath value that filters only modified field.
    if ($("#massUpdate2ApplyToWhat").val() !== "criticalPath" || TW.isResetValueOperation()) {
        inputs = inputs.filter(TW.massUpdateMap[$("#massUpdate2ApplyToWhat").val()]);
    }

    if (TW.isDueDateChange() && TW.isIncDecAmountOperation())
    {
        requestServerCacluatedDueDates(inputs);
        return;
    }

    inputs.each(function() {
        var newDuration;
        switch ($("#massUpdate2ChangeType").val()) {
            case "setValue":
                // Set direct value.
                if (TW.isDurationChange()) {
                    $(this).val(TW.durationObjectToString(getEnteredValue()));
                } else {
                    $(this).val(getEnteredValue());
                }
                break;
        
            case "resetToCurrent":
                // Reset to default value.
                $(this).defVal(null);
                break;
        
            case "increaseAmount":
            case "decreaseAmount":
                if ($(this).val() === "") return; // Skip empty durations of custom due date activities.
                var newValue = getEnteredValue();

                newValue.value *= (TW.isIncreaseAmountOperation() ? 1 : -1);
                var activityId = $(this).parent().parent().attr("tw:id");
                var hoursInOneDay = TW.dateMath.hoursInDay(activityId);
                newDuration = TW.dateMath.incDurationByDuration($(this).val(), newValue, hoursInOneDay);
                $(this).val(TW.durationObjectToString(newDuration));
                break;
        
            case "decreasePercent":
            case "increasePercent":
                    if ($(this).val() === "") return;  // Skip empty durations of custom due date activities.
                    var percentage = +$("#massUpdate2NewValue").val() * (TW.isIncreasePercentChange()? 1 : -1);
                    newDuration = TW.dateMath.incDurationByPercent($(this).val(), percentage);
                    $(this).val(TW.formatDuration(newDuration));
                break;
        }
        // Notify control of change.
        $(this).change();
    });

    /**
     * Request server to calculate due dates inc/dec by duration.
     * @param inputs input field list to be changed.
     */
    function requestServerCacluatedDueDates(inputs) {

        var massUpdate = {
            dueDates : {}
        };

        inputs.each(function() {
            var activityRow = $(this).parent().parent();
            var timeScheduleName = activityRow.attr("tw:timeScheduleName");
            var holidayScheduleName = activityRow.attr("tw:holidayScheduleName");
            var timeZoneName = activityRow.attr("tw:timeZoneName");

            massUpdate.dueDates[activityRow.attr("tw:id")] = {
                date    : $(this).val(),
                timeScheduleName: timeScheduleName,
                holidayScheduleName: holidayScheduleName,
                timeZoneName: timeZoneName
            };
        });

        massUpdate.command = $("#massUpdate2ChangeType").val();

        var newValueString = $("#massUpdate2NewValue").val();
        var translatedDuration = TW.parseDurationFromUserInput(newValueString);
        var englishDuration = TW.parseDurationFromFormFields(newValueString);

        if (translatedDuration != null) {
            $("#massUpdate2NewValue").val( TW.durationObjectToString(translatedDuration));
            massUpdate.duration = TW.durationObjectToString(englishDuration);
            var request = {
                action: "MASS_CHANGE",
                dueDates: JSON.stringify(massUpdate)
            };

            TW.sendAjaxRequest(request, function(json) { updateDueDates(json, inputs); });
        } else {
            $("#massUpdate2NewValue").addClass("error");
        }
    }

    /**
     * Called back when server has new due dates calculated and ready to put onto page.
     * @param json
     * @param inputs
     */
    function updateDueDates(json, inputs) {
        
        inputs.each(function() {
            
            var activityId = $(this).parent().parent().attr("tw:id");
            if (json[activityId]) {
                $(this).val(json[activityId]);
                $(this).change();
            }
        });
        
        TW.pageData.massUpdate = false;
        TW.resetPreview();
        TW.requestPreview();
        TW.pageData.loadingDialog.hide();
    }

    /**
     * Read value depending on mode.
     */
    function getEnteredValue() {
        if ($("#massUpdate2ChangeWhat").val() === "priority") {
            return $("#massUpdate2Priorities").val();
            
        } else if (TW.isDueDateChange()) {
            return $("#massUpdate2NewDueDateSpan :text").val();

        } else if (TW.isDurationChange()) {
            return TW.parseDurationFromUserInput($("#massUpdate2NewValue").val());
            
        } else {
            return null;
        }
    }

    TW.pageData.massUpdate = false;
    TW.resetPreview();
    TW.requestPreview();
    TW.pageData.loadingDialog.hide();
};

/**
 * This maps Mass Update mode values into CSS selectors for jQuery. 
 */
TW.massUpdateMap = {
    // Apply to type, #massUpdate2ApplyToType.
    "activities": ".activity",
    "tasks": ".task",
    // Filter, #massUpdate2ApplyToWhat.
    "all": "*",
    "changed": ".modified",
    "unchanged": ":not(.modified)",
     // "criticalPath" additional filter for Reset Value. Rows on Critical Path are filtered on row filtering stage #2.
    "criticalPath": ".modified"
};

TW.dateMath = {

    /**
     * Number of minutes in one hour.
     */
    MINUTES_IN_ONE_HOUR: 60,

    /**
     * Returns number of hours in a day for specific activity.
     * @param guid
     */
    hoursInDay: function(guid) {
        var row = $("tbody#dueDatesContent > tr").filter(function() {return $(this).attr('tw:id') == guid; });
        return +$(row).attr("tw:hoursperday");
    },

    /**
     * Increases and decreases duration by percent.
     * See incDurationByDuration(...) for details.
     *  
     * @param stringValue
     * @param percentage
     * @param hoursInOneDay
     */
    incDurationByPercent: function(stringValue, percentage, hoursInOneDay) {
        var duration = TW.parseDurationFromFormFields(stringValue);
    
        var increase = duration.value * percentage / 100;
        
        var incDuration = {
            value: increase,
            units: duration.units
        };
    
        return TW.dateMath.incDurationByDuration(duration, incDuration, hoursInOneDay);
    },

    /**
    * Returns the singular unit of any pluralized units
    */
    removePluralization: function(str) {
        if (str === "days") return "day";
        if (str === "months") return "month";
        if (str === "minutes") return "minute";
        if (str === "hours") return "hour";
        return str;
    },

    /**
    * Adds pluralization to a duration if needed
    */
    addPluralization: function(duration) {
        if (TW.isSingular(duration.value)) {
            return duration;
        }
        var tmp = duration.units;
        if (tmp === "day") tmp = "days";
        if (tmp === "month") tmp = "months";
        if (tmp === "minute") tmp = "minutes";
        if (tmp === "hour") tmp = "hours";

        duration.units = tmp;
        return duration;
    },

    /**
     * 
     * @param initialString
     * @param increaseString
     * @param hoursInOneDay
     */
    incDurationByDuration: function(initialString, increase, hoursInOneDay) {
        // since we know that units will always be in English at this point
        // of the code, we can remove the pluralizations
        var initial = TW.parseDurationFromFormFields(initialString);
        initial = TW.convertTranslatedToEnglishDurationObject(initial);
        initial.units = TW.dateMath.removePluralization(initial.units);

        increase = TW.convertTranslatedToEnglishDurationObject(increase);
        increase.units = TW.dateMath.removePluralization(increase.units);

        var result = {};
        var newValue;
    
        if (initial.units == "month" || increase.units == "month") { // Month + month
            if (increase.units == initial.units) {
                result.units = "month";
                result.value = initial.value + increase.value;
            } else {
                result = initial;
            }
        } else if (initial.units == "day" && increase.units == "day") { // Day + day
            result.units = "day";
            result.value = initial.value + increase.value;
    
        } else if (initial.units == "day") { // day + hour
                if (increase.units == "minute") { // day + minute
                    increase.value /= TW.dateMath.MINUTES_IN_ONE_HOUR;
                    increase.units = "hour";
                }
                newValue = initial.value + increase.value / hoursInOneDay;
                if (Math.abs(newValue) < 2 && Math.abs(increase.value) > 2) {
                   result.value = Math.round(hoursInOneDay * newValue);
                   result.units = "hour";
                } else {
                    result.value = Math.round(newValue);
                    result.units = "day";
                }
        } else if (initial.units == "hour" && increase.units == "minute") { // hour + min
            newValue = initial.value + increase.value / TW.dateMath.MINUTES_IN_ONE_HOUR;
            if (Math.abs(newValue) < 2 && Math.abs(increase.value) > 10) {
               result.value = Math.round(TW.dateMath.MINUTES_IN_ONE_HOUR * newValue);
               result.units = "minute";
            } else {
                result.value = Math.round(newValue);
                result.units = "hour";
            }
        } else if (initial.units == "hour") { // hour + hour
            if (increase.units == "day") {
                increase.units = "hour";
                increase.value *= hoursInOneDay;
            }
            result.units = "hour";
            result.value = initial.value + increase.value;
        } else if (initial.units == "minute") { // min + min
            if (increase.units == "day") {
                increase.units = "hour";
                increase.value *= hoursInOneDay;
            }
            if (increase.units == "hour") {
                increase.units = "minute";
                increase.value *= TW.dateMath.MINUTES_IN_ONE_HOUR;
            }
            result.units = "minute";
            result.value = initial.value + increase.value;
        } else {
            result = initial;
        }

        // add pluralizations back if necessary
        return TW.dateMath.addPluralization(result);
    }
};

/**
 * Removes option from select element and stores into a "twhidden" property.
 * Use
 * @param value Value of option to hide.
 */
jQuery.fn.hideOption = function(value) {
    $(this).filter("select").each(function() {
        var selectElement = this;


        $(this).find("option[value=" + value + "]").each(function() {
            if (!("twhidden" in selectElement) || !selectElement.twhidden) {
                selectElement.twhidden = [];
            }
            var optionWrapped = {
                index: this.index,
                option: this
            };
            selectElement.twhidden.push(optionWrapped);
        }).remove();
    });
    return $(this);
};

/**
 * Restores all hidden options from select.
 * Uses twhidden property to fetch option list.
 */
jQuery.fn.restoreOptions = function() {
    $(this).filter("select").each(function() {
        var selectElement = this;
        if ("twhidden" in selectElement && selectElement.twhidden)
            while(selectElement.twhidden.length > 0) {
                var optionWrapped = selectElement.twhidden.pop();
                this.insertBefore(optionWrapped.option, this.options[optionWrapped.index]);
            }
    });
    return $(this);
};
