// -------------------- Excel export --------------------
var tableIDsToExport = "instanceDetails,dueDates";

function addExportData(csvTable) {
   if (document.forms.exportData == null || document.forms.exportData.data == null) {
       return;
   }
   document.forms.exportData.data.value = "\uFEFF" + document.forms.exportData.data.value + "\n\n" + csvTable;
}
function doSubmitExport() {
  document.forms.exportData.data.value = "";
  var tableArr = tableIDsToExport.split(",");
  for (var i=0;i<tableArr.length;i++) {
    addTableToCSV(tableArr[i]);
  }
  document.forms["exportData"].submit();
}

function addTableToCSV(tableId) {
  var table;

  try {
    table = document.getElementById(tableId);

	// defect 97538 (part 1)
	// need to temporarily replace some elements in the table
	// because they do not export correctly:
	// - accessibility icons are replaced with empty span
	//   tags since they should not be exported
	// - drop downs are replaced with a span containing the
	//   currently selected text
  	var removed = new Array();
  	var iconA11y = dojo.query(".iconA11y",table);
  	var i;
  	for (i=0; i<iconA11y.length; i++) {
  	  var e = iconA11y[i];
	  var tmp = document.createElement('span');
  	  removed.push({element:e,tmp:tmp});
  	}
  	var selects = table.getElementsByTagName('select');
  	for (i=0; i<selects.length; i++) {
  	  var e = selects[i];
	  var tmp = document.createElement('span');
	  if (e.selectedIndex != -1) {
	  	tmp.innerHTML = e.options[e.selectedIndex].innerHTML;
	  }
  	  removed.push({element:e,tmp:tmp});
 	}
  	for (i=0; i<removed.length; i++) {
      var o = removed[i];
      var e = o.element;
      var tmp = o.tmp;
      e.parentNode.replaceChild(tmp,e);
  	}
  	
    var a = table.innerHTML;

    // defect 97538 (part 2)
    // restore temporarily replaced elements
    while (removed.length >0) {
      var o = removed.pop();
      var e = o.element;
      var tmp = o.tmp;
      tmp.parentNode.replaceChild(e,tmp);
      delete tmp;
    }

    //replace existing commas with semi-colons. Poor mans way of handling embedded commas in a csv file
    a = a.replace(/,/g, ";");

    //insert commas at the end of a table cell
    a = a.replace(/<\/td>/g, ",");
    a = a.replace(/<\/TD>/g, ",");
    a = a.replace(/<\/th>/g, ",");
    a = a.replace(/<\/TH>/g, ",");

    //insert a newline tag at the end of every row. Need to do this before removing all tags
    a = a.replace(/<\/tr>/g, "---newline---");
    a = a.replace(/<\/TR>/g, "---newline---");

    //remove html tags
    a = a.replace(/<\/?[^>]+(>|$)/g, "");

    //remove whitespace (regexs found via google)
    a = a.replace(/\r/g, " ");
    a = a.replace(/[^ \u80-\uFFFFFF`~!@#\$%\^&\*\(\)-_=\+\\\|\]\[\}\{'";:\?\/\.>,<]/g, "");
    a = a.replace(/'/g, "");
    a = a.replace(/ +/g, " ");
    a = a.replace(/^\s/g, "");
    a = a.replace(/\s$/g, "");

    //replace &nbsp which the coach designer inserts
    a = a.replace(/\&nbsp;/g, " ");

    //put newlines in
    a = a.replace(/---newline---/g, "\n");

    //a now holds a resonable csv that I can put in excel
    //alert(a);
    addExportData(a);
    return true;
  } catch (e) {
    alert(problemAddTable_Alert + e);
  }
  return true;
}
