/**
 * @module main
 * @dependencies core
 */

function pageLoad() {
	// RTC 122354 "Add 35px of spacing at the top of legacy dashboards."
	// This code handles PM SLA Overview, PM My Performance, PM My Team Performance and PM Process Performance
	// Ad-hoc reports is handled in src/modules/process-server.process-portal/src/main/resources/objects/1.3314acb8-e386-4d16-b186-44e78c80f16d.xml
	//This code also handles the MS Office add-ons.  This 35px is breaking that app.
	// RTC 146978 Don't add the 35px for MS Addons, process details view and popups.  Only added it if it is a Scoreboard.
	if (typeof dojo != "undefined") {
		if (window && window.location && window.location.pathname) {
			if ((window.location.pathname.indexOf("AdHoc")<0) && (window.location.pathname.indexOf("viewScoreboard")>=0) ) {
				var pageBody = dojo.body();
				if (pageBody) {
					dojo.style(pageBody, "marginTop", "35px");
				}
			}
		}	
	}
	// end 122354
    resize();
    setInterval("resize()", 500);
    setFocus();

    if (typeof handleToolbar == 'function') {
        handleToolbar();
    }
}        
        
function setFocus() {
    var b = document.getElementById("body");
    if (b) {
        b.focus();//a11y
    }
}

function resize() {
	var newHeight = 500;
	if (window.innerHeight)
		newHeight = window.innerHeight - 16;
	else
		newHeight = document.documentElement.clientHeight - 16;
	if (document.getElementById("header"))
		newHeight = newHeight - 50;

    if (newHeight <= 50) {
        newHeight = 50;
    }

    if (document.getElementById("content") != null) {
        document.getElementById("content").style.height = newHeight + 'px';
    }
}

function selectRow(what) {
	var row = document.getElementById("row" + what);
	var check = document.getElementById("item" + what);
	check.blur();

	if (check.checked) {
		row.style.backgroundColor = "#e0f6ff";
	} else {
		row.style.backgroundColor = "#ffffff";
    }
}

function ajax(t, url, onreadystatechange) {
    t.req = tw.js.getXMLHttpTransport();
    if (t.req == null) {
		alert(problemAjax_Alert);
    }
    if (t.req) {
        t.req.onreadystatechange = onreadystatechange;
        t.req.open("GET", url, true);
        // Set this header to prevent caching of response by IE
        t.req.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT");
        t.req.send("");
    }
}
