/**********************************************************************
* Licensed Materials - Property of IBM
*
* 5724-R31, 5655-S30
*
* (C) Copyright IBM Corp. 2011. All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
**********************************************************************/

/**
 * The module providing facilities for functioning of Advanced Search Web UI
 * 
 * @module search
 * @dependencies core(core.jsp)
 */
 
dojo.require("com.lombardisw.DateTimePicker");
 
var optionValue=new Array(0);
var count=0;

var valInstancePrefix = "Instance:";
var valTaskPrefix = "Task:";
var valBDPrefix = "BD:";


function doDelete(searchId) {
    if (confirm(deleteSearch_Confirm)) {
        document.cookie = "curNavItem"+"="+escape('adminsaved0');
        document.location.href = "deleteSearch.do?searchId=" + searchId;
    }
}

function doSave() {
     var MAX_SEARCH_NAME_LENGTH = 30;
     // regular expression for special symbols
     var specialSymbols =/[&#]/;

     var name = prompt(newSharedSearch_Prompt_AddName,"");

     if(name == null) {
        // cancel button precced
     } else if( specialSymbols.test(name)){
        alert (specialSimbolsInNewSavedSearchName);
     } else if ((name.length == 0) || (name == helpRequest_Value)) {
        alert (newSharedSearch_Alert_BadName_start + name + newSharedSearch_Alert_BadName_end);
     } else if (name.length > 30){
        alert (newSharedSearch_Alert_NameToLong + MAX_SEARCH_NAME_LENGTH);
     } else {
        document.location.href="saveSearch.do?&name=" + encodeURI(name);
     }
}

function doShare(searchId) {
    if (confirm(shareSearch_Confirm)) {
        document.location.href = "shareSearch.do?searchId=" + searchId;
    }
}

function addButtonPressed(index) {
    //COUNT_CONSTRAINTS=COUNT_CONSTRAINTS+1;
    hideButtons(index);
    exposeCondition(index + 1);
    exposeButtons(index + 1);
    setConditionCount(index + 2);
}

function removeButtonPressed(index) {
    hideButtons(index);
    hideCondition(index);
    exposeButtons(index - 1);
    setConditionCount(index);
}

function exposeCondition(index) {
    var conditionDiv = document.getElementById('condition' + index);
    conditionDiv.style.display = 'block';
    count++;
}

function exposeButtons(index) {
    var addRemoveDiv = document.getElementById('addRemove' + index);
    addRemoveDiv.style.display = 'block';
}

function hideCondition(index) {
    var conditionDiv = document.getElementById('condition' + index);
    conditionDiv.style.display = 'none';
}

function hideButtons(index) {
    var addRemoveDiv = document.getElementById('addRemove' + index);
    addRemoveDiv.style.display = 'none';
}

function hideSaveSearch() {
    var saveSearchButton = document.getElementById("saveSearchButton");
    if (saveSearchButton != null && saveSearchButton.style.visibility != "hidden") {
        saveSearchButton.style.visibility = "hidden";
    }
}

function setConditionCount(count) {
    document.getElementById('conditionCount').value = count;
}

function validateConstraint() {
    var condition='condition'+count+'value';
    var isEntered=false;

    for (i = 0; i <= count; i++) {
        var condition = 'condition' + i + 'value';
        optionValue[i] = document.getElementById(condition).value;
    }

    for (p = 0; p <= count; p++) {
        if (optionValue[p].length<=0) {
            alert(conditions_AddValuesForDefinedConditions_Alert);
            isEntered=false;
            break;
        } else {
            isEntered=true;
            continue;
        }
    }
    return isEntered;
}


function toggleSearch(div, button)
{
    if (document.getElementById(div).style.display == 'block') {
        document.getElementById(div).style.display = 'none';
        button.value = newSharedSearch_Button_ShowSearch;
    } else {
        document.getElementById(div).style.display = 'block';
        button.value = newSharedSearch_Button_HideSearch;
    }
}

 function changeSearchOrganization(){
    var searchForm = document.getElementById("searchFormId");
    searchForm.tasksShows.checked = !searchForm.tasksShows.checked;
    hideSaveSearch();
    searchForm.searchSubmit.onclick();
 }

function toggle(f,s) {
    if (document.getElementById(f).style.display == 'none') {
        document.getElementById(f).style.display = 'block';
        document.getElementById(s).style.display = 'none';
    } else {
        document.getElementById(f).style.display = 'none';
        document.getElementById(s).style.display = 'block';
    }
    return false;
}

function updateOperator(t, possibleValue) {

    checkHtmlSelect(t);
    //var selection = (t.selectedIndex != -1) ? t.options[t.selectedIndex].value : undefined;
    initializeOperator(t, possibleValue);

    var validvalue = t.id.replace(/column/, 'value');
    var val = document.getElementById(validvalue);
    //onConditionChange(val);
}

function isIE() {
	return navigator.userAgent.indexOf("MSIE") > -1;
}

// This function is required for correct (compatible with other browsers) innerHTML functionality under IE.
function setInnerHTML(node, value) {
	if (isIE()) {
		var child;
		while (child = node.firstChild)
			node.removeChild(child);
	}
	node.innerHTML = value;
}

function initializeOperator(t, possibleValue) {
    var value = t.value;
    var columnsidvalue = t.id.replace(/column/, 'operator');
    var column = document.getElementById(columnsidvalue);

    if (t.value == BusinessDataConstants.BUSINESS_DATA_COLUMN) {
      // for business data we should move on one position
      // we put operator field into value field -> 'p' instead of 'opp'
      // for value paragraph 'condition<%=i%>bdValue'
      {
          var paragraphID = t.id.replace(/column/, 'opp');
          var pcell = document.getElementById(paragraphID);
          var selectID = t.id.replace(/column/, BusinessDataConstants.ALIAS_ID_PEFIX);
          var operatorsSelectID = t.id.replace(/column/, 'operator');
          var valuesSelectID = t.id.replace(/column/, 'value');
          var selectTags = '<select class="condition" id="' + selectID + '" name="' + selectID + '" size="1" '
             + ' style="width: 146px; height:20px" '
             + ' onchange="hideSaveSearch(); if (this.value && (this.value != \'\')) { '
             + ' fillOperatorsForType(\'' + operatorsSelectID + '\', extractBDTypeFromVarName(this.value)); '
             + ' changeInputElementIfDateTime(\'' + valuesSelectID + '\', this.value); '
             + ' }; return ;" '
             + '>'
   	         + '</select>';

          pcell.innerHTML = selectTags;
          var select = getHtmlSelectElement(selectID);
          //select.options.clear = 0;
          // bdSearchAliases contains BDSearchVariable objects 
          select.options.add(new Option("", ""));
          for (var i=0; i<bdSearchAliases.length; i++) {
            var alias = bdSearchAliases[i];
            select.options.add(new Option(alias.getHumanName(),
               BusinessDataConstants.PROP_BUSINESS_DATA_PREFIX
                + alias.getTypeQualifiedName()));
            //if (selectItem && ((selectItem == op) || (selectItem == select.options[i].value))) {
            //  __selectSelectOptionByIndex(obj, i);
            //}
          }
      }
      {
	      var paragraphID = t.id.replace(/column/, 'p');
	      var pcell = document.getElementById(paragraphID);
	      var selectID = t.id.replace(/column/, 'operator');
	      var selectTags = '<select class="condition" id="' + selectID + '" name="' + selectID + '" size="1" '
	         + ' style="width: 146px; height:20px" onchange="hideSaveSearch(); return ;"></select>';
	      setInnerHTML(pcell, selectTags);
	      fillOperatorsForType(selectID, TWType.STRING, null);
      }
      {
	      var paragraphID = t.id.replace(/column/, 'bdValue');
	      var pcell = document.getElementById(paragraphID);
	      var inputID = t.id.replace(/column/, 'value');
	      var inputTags = '<input type="text" id=' + inputID + ' name=' + inputID
	         + ' style="width: 142px; height:15px;border: 1px solid #3161bd;" '
	         + ' maxlength="32" onBlur="onConditionChange(this)" '
	         + ' value="' + (possibleValue ? possibleValue : '') + '" '
	         + ' onchange="hideSaveSearch();"/>';
		  pcell.innerHTML = inputTags;		  
	      changeInputElementIfDateTime(inputID, select.value, possibleValue);
      }
      return;
    }
    else {
      // hide bdValue field
      var paragraphID = t.id.replace(/column/, 'bdValue');
      var pcell = document.getElementById(paragraphID);
      pcell.innerHTML = "";
    }

    if((value=="instanceStatus")|(value=="taskStatus")|(value=="taskPriority")|(value=="bpdName"))
    {

        var validvalue = t.id.replace(/column/, 'value');

        var pvalue = t.id.replace(/column/, 'p');

        var pcell=document.getElementById(pvalue);
        var s1  ='<select class="condition" id='+validvalue+' name='+validvalue+'  size="1" style="width: 146px; height:20px" onchange="hideSaveSearch();">'
        if(value=="instanceStatus")
        {
            for(i=0;i<instanceStatusCodeList.length;i++)
            {

                s1=s1+' <option '+((possibleValue && possibleValue==instanceStatusValueCodeList[i])?'SELECTED ':' ')+'value="'+instanceStatusValueCodeList[i]+'">'+instanceStatusCodeList[i]+'</Option>';

            }
        }
        else if(value=="taskStatus")
        {
            for(i=0;i<taskStatusCodeList.length;i++)
            {

                s1=s1+' <option '+((possibleValue && possibleValue==taskStatusCodeValueList[i])?'SELECTED ':' ')+'value="'+taskStatusCodeValueList[i]+'">'+taskStatusCodeList[i]+'</Option>';

            }

        } else if(value=="taskPriority")
        {
            for(i=0;i<taskPriorityList.length;i++)
            {

                s1=s1+' <option '+((possibleValue && possibleValue==taskPriorityList[i])?'SELECTED ':' ')+'value="'+taskPriorityList[i]+'">'+taskPriorityList[i]+'</Option>';

            }

        }
        else if(value=="bpdName") {
            var dropDownCell = pcell;
            ajax(t, 'getBpdList.do', function () {
                if (t.req.readyState == 4) {
                    if (t.req.status == 200) {
                        var doc = t.req.responseXML;
                        var bpds = doc.getElementsByTagName('BPD');
                        var select  ='<select class="condition" id='+validvalue+' name='+validvalue+'  size="1" style="width: 146px; height:20px" onchange="hideSaveSearch();">'

                        for (var i=0; i < bpds.length; i++) {
                            // Pull out the values from the xml response
                            var name = bpds[i].getElementsByTagName("NAME")[0].firstChild.data;
                            var project = bpds[i].getElementsByTagName("PROJECT")[0].firstChild.data;
                            var displayName = name;
                            if ((project != "null") && (project != undefined) && (project != "")) {
                                displayName = displayName + " (" + project + ")";
                            }
                            var bpdRef = bpds[i].getElementsByTagName("REF")[0].firstChild.data;
                            var vc = bpds[i].getElementsByTagName("VERSION")[0].firstChild.data;
                            //Build the onclick event
                            var click = ' onClick=getBusinessDataForProcess(this,\"'+ bpdRef +'\",\"' + vc + '\");';

                            select=select+' <option '+((possibleValue && possibleValue==name) ? 'SELECTED ' : ' ')+'value="'+ name + '"' + click +'>'+displayName+'</option>';
                        }
                        select = select + ' </select>';
                        dropDownCell.innerHTML=select;
                    } else {
                        alert( problemRetrievingXMLData_Alert + "\n" + t.req.statusText);
                    }
                }
            });
        }

        s1=s1+' </select>';

        setInnerHTML(pcell, s1);
    } else if((value=="instanceDueDate")|(value=="taskDueDate")|(value=="instanceCreateDate")|(value=="instanceModifyDate")) {
        var pvalue = t.id.replace(/column/, 'p');
        var validvalue = t.id.replace(/column/, 'value');
        var pcell = document.getElementById(pvalue);

        setInnerHTML(pcell, "");

        dojo.addClass(dojo.body(), "soria");

        var dateWidget = dijit.byId(validvalue);
		// fix for work item 92353 & 94794
        if(dateWidget != null && isIE()){
        	var vlueDate = dateWidget.getValue();
        	dateWidget.destroyRecursive();
        	dateWidget = new com.lombardisw.DateTimePicker({ "id": validvalue, "name": validvalue });
        	dateWidget.setValue(vlueDate);
        }
        if (dateWidget == null) {
        	if (getDojoDatePackageAsString() == 'dojo.date') {
        		dateWidget = new com.lombardisw.DateTimePicker({ "id": validvalue, "name": validvalue });
        	} else {
        		var dateClass = dojo.getObject(getDojoDatePackageAsString() + ".Date", false);
        		var dateObj = new dateClass;
        		dateWidget = new com.lombardisw.DateTimePicker({ "id": validvalue, "name": validvalue, "datePackage": getDojoDatePackageAsString(), "value": dateObj });
        	}
        }
        pcell.setAttribute("class", "soria");
        dojo.byId(pvalue).appendChild(dateWidget.domNode);
        dateWidget.startup();
    }
    else
    {
        var pvalue = t.id.replace(/column/, 'p');
        var validvalue = t.id.replace(/column/, 'value');
        var pcell = document.getElementById(pvalue);
        var s2="";
        s2 =s2+ '<input type="text" id='+validvalue+'  style="width: 142px; height:15px;border: 1px solid #3161bd;" name='+validvalue+' maxlength="32" onBlur="onConditionChange(this)" value="'+(possibleValue?possibleValue:'')+'" onchange="hideSaveSearch();" onkeyup="setDynamicElementDirection(this);"/>';
        setInnerHTML(pcell, s2);
    }

    // munge the operator dropdown: only show "before" and "after" for date columns, show everything otherwise
    // try to preserve last selection
    var opSelectId = t.id.replace(/column/, 'operator');
    
    var selectedOp = null;
    var opSelector = document.getElementById(opSelectId);
    for (var i = 0; opSelector && opSelector.options && (i < opSelector.options.length); i++) {
        if (opSelector.options[i].selected) {
            selectedOp = opSelector.options[i].value;
            break;
        }
    }
    var pvalue = t.id.replace(/column/, 'opp');
    var pcell = document.getElementById(pvalue);
    var s1  ='<select class="condition" id='+opSelectId+' name='+opSelectId+'  size="1" style="height:20px" onchange="hideSaveSearch();">'
    if ((value=="instanceDueDate")|(value=="taskDueDate")|(value=="instanceCreateDate")|(value=="instanceModifyDate")) {
        s1=s1+' <option value="LessThan">'   + displayName_LessThan    + '</option>';
        s1=s1+' <option value="GreaterThan">'+ displayName_GreaterThan + '</option>';
    } else if ((value=="assignedToUser")|(value=="assignedToRole")){
        s1=s1+' <option value="Equals">'     + displayName_Equals      + '</option>';
        s1=s1+' <option value="NotEquals">'  + displayName_NotEquals   + '</option>';
        s1=s1+' <option value="Contains">'   + displayName_Contains    + '</option>';
        s1=s1+' <option value="StartsWith">' + displayName_StartsWith  + '</option>';
    } else {
        s1=s1+' <option value="Equals">'     + displayName_Equals      + '</option>';
        s1=s1+' <option value="NotEquals">'  + displayName_NotEquals   + '</option>';
        s1=s1+' <option value="Contains">'   + displayName_Contains    + '</option>';
        s1=s1+' <option value="StartsWith">' + displayName_StartsWith  + '</option>';
        s1=s1+' <option value="LessThan">'   + displayName_LessThan    + '</option>';
        s1=s1+' <option value="GreaterThan">'+ displayName_GreaterThan + '</option>';
    }
    s1=s1+' </select>';
    pcell.innerHTML=s1;
    if (selectedOp != null) {
        opSelector = document.getElementById(opSelectId);
        for (var i = 0; i < opSelector.options.length; i++) {
            if (selectedOp == opSelector.options[i].value) {
                opSelector.options[i].selected = true;
                break;
            }
        }
    }

    if (value == 'bpdName') {
        // TODO: Delete and ignore if two or more selected
        column.selectedIndex = 0;
        column.disabled = true;
    } else {
        column.disabled = false;
    }
}
/**
 * Change SELECT to a date time widget
 */
function changeInputElementIfDateTime(id, bdSelectValue, value) {
    if(!bdSelectValue) {
		if(!value) {
			return;
		}
		else {
			var matchArray = value.match(/\d{4}-\d{1,2}-\d{1,2} \d{2}:\d{2}:\d{2}$/);
			if(matchArray) {
				var valueIsValidDate = true;
			}
		}
	}
	
	if(valueIsValidDate || extractBDTypeFromVarName(bdSelectValue) == TWType.DATE || extractBDTypeFromVarName(bdSelectValue) == TWType.TIME) {
		dojo.addClass(dojo.body(), "soria");
		if(dojo.byId(id) == undefined) {
			return;
		}
		if(dijit.byId(id)) {
			dijit.byId(id).destroyRecursive();
		}
		
		var paragraphID = id.replace(/value/,'bdValue');
		var pcell = dojo.byId(paragraphID);
		if(pcell == undefined) {
			return;
		}
		pcell.innerHTML = "";
		
		var dateWidget = new com.lombardisw.DateTimePicker({ "id": id, "name": id});
		if(value) {
			dateWidget.attr("value", dojo.date.locale.parse(value, {datePattern: dateWidget.statics.datePattern, timePattern: dateWidget.statics.timePattern}));
		}
		pcell.appendChild(dateWidget.domNode);
		dateWidget.startup();
	} else {
		var paragraphID = id.replace(/value/,'bdValue');
		var pcell = dojo.byId(paragraphID);
		if(pcell == undefined) {
			return;
		}
		
		var inputTags = '<input type="text" id="' + id + '" name="' + id
			 + '" style="width: 142px; height:15px;border: 1px solid #3161bd;" '
			 + ' maxlength="32" onBlur="onConditionChange(this)" '
			 + ' value="" '
			 + ' onchange="hideSaveSearch();"/>';
		pcell.innerHTML = inputTags;
	}
}
var prevBPDName = ""; // !!! bpdName with successful loading data from server

function getBusinessDataForProcess(t, bpdRef, versioningContext) {
    var columnsidvalue = t.id.replace(/value/, 'column');
    var column = document.getElementById(columnsidvalue);
    ajax(t, 'getBusinessData.do?bpdRef=' + bpdRef + '&versioningContext=' + versioningContext, function () {
        if (t.req.readyState == 4) {
            if (t.req.status == 200) {
                var inColList  = document.getElementById('itemPossibleColumns');
                var outColList = document.getElementById('itemDisplayColumns');
                removeBPDVars(inColList);
                removeBPDVars(outColList);

                //var bd = document.getElementById('bdPossibleColumns');
                if (inColList && inColList.options) {
                    var doc = t.req.responseXML;
                    /* var descriptions = doc.getElementsByTagName('DESCRIPTION');
                    for (var i=0; i < descriptions.length; i++) {
                        var value = descriptions[i].firstChild.data;
                        inColList.options[inColList.options.length] = new Option(labelBDPrefix + value, valBDPrefix + value);
                    }*/
                    // now we can get type information and add it to the option business data value.
                    // for instance option value for bd variable 'varA' will be BD:varA@boolean
                    var columns = doc.getElementsByTagName('COLUMN');
                    for (var i=0; i < columns.length; i++) {
                        var description = columns[i].getElementsByTagName("DESCRIPTION")[0];
                        var descriptionValue = description.firstChild.data;
                        var type = columns[i].getElementsByTagName("TYPE")[0];
                        var typeValue = type.firstChild.data;
                        inColList.options[inColList.options.length] = new Option(labelBDPrefix + descriptionValue,
                                valBDPrefix + descriptionValue + "@" + typeValue);
                    }
                }
                //var bdvc = document.getElementById('bdDisplayColumns');
                if (outColList && outColList.options) {
                    for (var i=0; i<outColList.options.length; i++) {
                        if (startsWith(outColList.options[i].value, valBDPrefix)) // BPD variable
                          removeactiveoption(outColList.options[i]);
                    }
                }
            } else {
                alert( problemRetrievingXMLData_Alert + "\n" + t.req.statusText);
            }
        }
    });
}

function onConditionChange(t) {
//    var processName = t.value;
//    var columnsidvalue = t.id.replace(/value/, 'column');
//    var column = document.getElementById(columnsidvalue);
}


function removeAllOptions(selectObj) {
  if (typeof(selectObj) == 'string')
     selectObj = document.getElementById(selectObj);
  while (selectObj.options.length != 0) {
    selectObj.remove(selectObj.options.length - 1);
  }
}

function removeBPDVars(selectObj) {
  if (typeof(selectObj) == 'string')
     selectObj = document.getElementById(selectObj);
  for (var i = 0; i<selectObj.options.length; i++) {
    if (startsWith(selectObj.options[i].value, valBDPrefix)) { // BPD variable
      // remove option
      //selectObj.options[i] = null;
      selectObj.remove(i);
      i--;
    }
  }
}


function moveBdColumns(form, from, to, add, copyValueToText) {
    var movedOptions = moveColumns(from, to, add, copyValueToText);

    var inputs = form.getElementsByTagName('input');

    for (var i = 0; i < movedOptions.length; i++) {

        var option = movedOptions[i];

        var rename = null;

        for (var i=0; i<inputs.length; i++) {
            if (inputs[i].name == option.value) {
                rename = inputs[i];
            }
        }

        if (rename == null) {
            // Add hidden input
            var hidden = document.createElement('input');
            hidden.setAttribute('type', 'hidden');
            hidden.setAttribute('name', option.value);
            hidden.setAttribute('value', option.text);
            form.appendChild(hidden);
        } else {
            rename.value = option.text;
        }
    }
}

function moveColumns(from, to, add, copyValueToText) {
    var f = document.getElementById(from);
    var t = document.getElementById(to);
    var movedOptions = [];

    for (var i = 0; i < f.options.length;) {
        var o = f.options[i];
        if (o.selected) {
            f.remove(i);
            if (copyValueToText) {
                o.text = o.value;
            }
            t.options[t.options.length] = o;
            movedOptions[movedOptions.length] = o;
            if (add) {
                if (f.onchange) f.onchange(f);
                if (t.onchange) t.onchange(t);
            } else {
                if (f.onchange) f.onchange(f);
                if (t.onchange) t.onchange(t);
            }
        } else {
            i++;
        }
    }
    return movedOptions;
}

// its version like moveBdColumns
function moveColumns2(from, to, add, form, copyValueToText) {
    var movedOptions = moveColumns(from, to, add, copyValueToText);
    var inputs = form.getElementsByTagName('input');

    for (var i = 0; i < movedOptions.length; i++) {
        var option = movedOptions[i];
        if (!startsWith(option.value, valBDPrefix))
            continue;
        // special processing BD fields
        var rename = null;

        for (var i=0; i<inputs.length; i++) {
            if (inputs[i].name == option.value) {
                rename = inputs[i];
            }
        }

        if (rename == null) {
            // Add hidden input
            var hidden = document.createElement('input');
            hidden.setAttribute('type', 'hidden');
            hidden.setAttribute('name', option.value);
            hidden.setAttribute('value', option.text);
            form.appendChild(hidden);
        } else {
            rename.value = option.text;
        }
    }

	// Synchronize "sort1" and "sort2" selectors after the items
	// have been moved to "result" column list
    var sortColumnSelector1 = document.getElementById("sort1");
    var sortColumnSelector2 = document.getElementById("sort2");
    for (var i = 0; i < movedOptions.length; i++) { // for each moved item
        var option = movedOptions[i];
        // Get unqualified(unprefixed) name of the item
    	var value = getUnqualifiedVarNameFromOptionValue(option.value);
	    if (!containsOption(sortColumnSelector1, value)) {
	    	var copy = createOption(option.text, value);
	    	sortColumnSelector1.options[sortColumnSelector1.options.length] = copy;
	    }
	    if (!containsOption(sortColumnSelector2, value)) {
	    	var copy = createOption(option.text, value);
	    	sortColumnSelector2.options[sortColumnSelector2.options.length] = copy;
	    }
	}
	
    if (copyValueToText)
        updateBDTextForSelectItems(document.getElementById(to));
}

function createOption(text, value) {
	var taskPf = document.getElementById("newsearch.Task.prefix").value;
	var instancePf = document.getElementById("newsearch.Instance.prefix").value;
	var bdPf = document.getElementById("newsearch.BusinessData.prefix").value;
	
	var dt = text;
	if (startsWith(dt, taskPf)) {
		dt = dt.substring(taskPf.length);
	} else if (startsWith(dt, instancePf)) {
		dt = dt.substring(instancePf.length);
	} else if (startsWith(name, bdPf)) {
		dt = dt.substring(bdPf.length);
	}
	
	return new Option(dt, value);
}

// its version like moveBdColumns
function moveColumns3(from, to, add, form, copyValueToText) {
    var movedOptions = moveColumns(from, to, add, copyValueToText);
	// Synchronize "sort1" and "sort2" selectors after the items
	// have been removed from "result" column list
    var sortColumnSelector1 = document.getElementById("sort1");
    var sortColumnSelector2 = document.getElementById("sort2");
    for (var i = 0; i < movedOptions.length; i++) { // for each removed item
        var option = movedOptions[i];
        // Get unqualified(unprefixed) name of the item
    	var value = getUnqualifiedVarNameFromOptionValue(option.value);
	    if (containsOption(sortColumnSelector1, value)) {
			if (removeoption(sortColumnSelector1, value)) {
				// If removed item was selected then reset selection to "not defined".
				sortColumnSelector1.selectedIndex = 0;
			}
	    }
	    if (containsOption(sortColumnSelector2, value)) {
			if (removeoption(sortColumnSelector2, value)) {
				// If removed item was selected then reset selection to "not defined".
				sortColumnSelector2.selectedIndex = 0;
			}
	    }
	}

    if (copyValueToText)
        updateBDTextForSelectItems(document.getElementById(to));
}

function getUnqualifiedVarNameFromOptionValue(qualifiedName) {
	var name = qualifiedName;
	if (startsWith(name, valInstancePrefix)) {
		name = name.substring(valInstancePrefix.length);
	} else if (startsWith(name, valTaskPrefix)) {
		name = name.substring(valTaskPrefix.length);
	} else if (startsWith(name, valBDPrefix)) {
		name = name.substring(valBDPrefix.length);
	}
	
	return name;
}

function updateBDTextForSelectItems(select) {
    var options = select.options;
    for (i=0; i<options.length; i++) {
        var val = options[i].value;
        var text = options[i].text;
        if (startsWith(val, valBDPrefix) && startsWith(text, valBDPrefix)) {
       		// Remove BD qualifier(prefix)
            var unqualifiedName = text.substring(valBDPrefix.length);
            // Remove type specifier if any
            unqualifiedName = removeBDTypeFromVarName(unqualifiedName);
            options[i].text = labelBDPrefix + unqualifiedName;
        }
    }
}

/** 
 * Check whether the given selector (Select object) contains an option
 * with the given value.
 * 
 * @param {Select} select the selector in which to search.
 * @param {String} value the value to be checked.
 * @return {Boolean} true if the option was found, false otherwise.
 * 
 * @see findOption()
 */
function containsOption(select, value) {
	return findOption(select, value) != -1;
}

/**
 * Find an option with the given value in the given selector (Select object).
 * 
 * @param {Select} select the selector in which to search.
 * @param {String} value the value to be found.
 * @return {Integer} index of the option in the selector or -1 if an option not found.
 */
function findOption(select, value) {
    var options = select.options;
    for (i=0; i < options.length; i++) {
        var value2 = options[i].value;
        if (value2 == value) {
            return i;
        }
    }
    return -1;
}

function reorderColumns(id, dir) {
    var s = document.getElementById(id);
    if (dir == 'up') {
        for (var i = 0; i < s.options.length; i++) {
            if (s.options[i].selected) {
                if (i > 0) {
                    var otext = s.options[i].text;
                    var ovalue = s.options[i].value;
                    s.options[i].text = s.options[i-1].text;
                    s.options[i].value = s.options[i-1].value;
                    s.options[i].selected = s.options[i-1].selected;
                    s.options[i-1].text = otext;
                    s.options[i-1].value = ovalue;
                    s.options[i-1].selected = true;
                    /*
                    var temp = s.options[i];
                    s.options[i] = s.options[i-1];
                    s.options[i-1] = temp;
                    */
                }
            }
        }
    } else {
        for (var i=s.options.length-1; i >= 0; i--) {
            if (s.options[i].selected) {
                if (i < s.options.length-1) {
                    var otext = s.options[i].text;
                    var ovalue = s.options[i].value;
                    s.options[i].text = s.options[i+1].text;
                    s.options[i].value = s.options[i+1].value;
                    s.options[i].selected = s.options[i+1].selected;
                    s.options[i+1].text = otext;
                    s.options[i+1].value = ovalue;
                    s.options[i+1].selected = true;
                    /*
                    var temp = s.options[i];
                    s.options[i] = s.options[i+1];
                    s.options[i+1] = temp;
                    */
                }
            }
        }
    }
}

/*
function convertResultColumns(inst,task) {
    inst_list = eval(document.getElementById("instanceDisplayColumns"));
    task_list = eval(document.getElementById("taskDisplayColumns"));

{
    var select = document.getElementById("instanceDisplayColumns");
    var hidden = document.getElementById("instanceResultColumns");
    convertColumns(select, hidden);
}
{
    var select = document.getElementById("taskDisplayColumns");
    var hidden = document.getElementById("taskResultColumns");
    convertColumns(select, hidden);
}
{
    var select = document.getElementById("bdDisplayColumns");
    var hidden = document.getElementById("bdResultColumns");
    convertColumns(select, hidden);
}
}
*/

function convertResultColumns(inst,task) {
    inst_list = eval(document.getElementById("instanceDisplayColumns"));
    task_list = eval(document.getElementById("taskDisplayColumns"));

{
    var select = document.getElementById("itemDisplayColumns");
    var hidden = document.getElementById("itemResultColumns");
    convertColumns(select, hidden);

    /*
    hidden = document.getElementById("instanceResultColumns");
    convertColumnsUsingPrefix(select, hidden, valInstancePrefix)

    hidden = document.getElementById("taskResultColumns");
    convertColumnsUsingPrefix(select, hidden, valTaskPrefix)

    hidden = document.getElementById("bdResultColumns");
    convertColumnsUsingPrefix(select, hidden, valBDPrefix)
    */
}
}

function convertColumns(select, hidden) {
    var hiddenValue = '';
    for (var i = 0; i < select.options.length; i++) {
        if (i != 0) {
            hiddenValue = hiddenValue + "|"
        }
        hiddenValue = hiddenValue + select.options[i].value;
    }
    hidden.value = hiddenValue;
}

function startsWith(str, prefix) {
    str = "" + str; // to make sure
    if (str.length < prefix.length)
        return false;
    return prefix == str.substr(0, prefix.length);
}

function convertColumnsUsingPrefix(select, hidden, prefix) {
    var hiddenValue = '';
    for (var i = 0; i < select.options.length; i++) {
        var val = select.options[i].value;
        if (startsWith(val, prefix))
            val = val.substr(prefix.length);
        else
            continue;
        if (hiddenValue.length != 0) {
            hiddenValue = hiddenValue + "|"
        }
        hiddenValue = hiddenValue + val;
    }
    hidden.value = hiddenValue;
}


function addoption(s, value, text) {
    var no = new Option(value, text);
    var source = s.options;
    var target = new Array();
    // HACK: Ignore first option, which is "choose one"
    target[0] = source[0];
    var j = 1;
    var selected = null;
    for (var i = 1; i < source.length; i++) {
        var o = source[i];
        if (o.selected) selected = o;
        if ((no != null) && (o.text < no.text)) {
            target[j++] = o;
        } else {
            if (no != null) {
                target[j++] = no;
                no = null;
            }
            target[j++] = o;
        }
    }
    if (i == j) {
        target[j++] = no;
    }
    while (source.length > 0) {
        source[0] = null;
    }
    var si = 0;
    for (var i = 0; i<target.length; i++) {
        source[i] = target[i]
        if (source[i] == selected) {
            source[i].selected = true;
            si = i;
        }
    }
    s.selectedIndex = si;
}

function removeoption(s, value) {
	var index = findOption(s, value);
	if (index == -1)
		return false;
	var option = s.options[index];
    var selected = option.selected;
	s.options[index] = null;
    return selected;
}


function removeactiveoption(o) {
    // Remove from sort lists
    var s1 = document.getElementById('sort1');
    var s2 = document.getElementById('sort2');
    removeoption(s1, o.value);
    removeoption(s2, o.value);
    if (s1.selectedIndex == 0) {
        s1.selectedIndex = s2.selectedIndex;
        s2.selectedIndex = 0;
    }
}

function enableSelects(t) {
    var selects = t.getElementsByTagName('select');
    for (var i=0; i<selects.length; i++) {
        selects[i].disabled = false;
    }
}

// Business data renaming code
/*
function checkRename(t) {
    if (selectedCount(t) == 1) {
        var div = document.getElementById("renameDiv");
        var original = document.getElementById("renameTextOriginal");
        var text = document.getElementById("renameTextInput");
        var option = t.options[t.selectedIndex];
        option.select = t;
        original.innerHTML = option.value;
        text.value = option.text;
        text.option = option;
        text.readOnly = false;
        text.disabled = false;
        div.style.display='block';
    } else {
        disableRenameEdit();
    }
}
*/

function checkRenameBD(t) {
    if (selectedCount(t) == 1) {
        var option = t.options[t.selectedIndex];
        if (!startsWith(option.value, valBDPrefix))
            return;

        var div = document.getElementById("renameDiv");
        var original = document.getElementById("renameTextOriginal");
        var text = document.getElementById("renameTextInput");
        option.select = t;
        var bdVarName = option.value.substring(valBDPrefix.length);
        // TODO: add comment about labelBDPrefix !
        var bdVarAlias = option.text.substring(labelBDPrefix.length);
        original.innerHTML = bdVarName;
        text.value  = bdVarAlias;
        //text.option = option;
        text.bdVarName = bdVarName;
        text.readOnly = false;
        text.disabled = false;
        div.style.display='block';
    } else {
        disableRenameEdit();
    }
}


function disableRenameEdit() {
    var div = document.getElementById("renameDiv");
    var original = document.getElementById("renameTextOriginal");
    var text = document.getElementById("renameTextInput");
    original.innerHTML = '&nbsp;';
    text.value = '';
    text.option = null;
    text.readOnly = true;
    text.disabled = true;
    div.style.display='none';
}

/*
function renameOption(text) {
    var option = text.option;
    option.text = text.value;
    option.selected = false;

    var form = option.form;
    var rename = null;
    var inputs = form.getElementsByTagName('input');
    for (var i=0; i<inputs.length; i++) {
        if (inputs[i].name == option.value) {
            rename = inputs[i];
        }
    }

    if (rename == null) {
        // Add hidden input
        var hidden = document.createElement('input');
        hidden.setAttribute('type', 'hidden');
        hidden.setAttribute('name', option.value);
        hidden.setAttribute('value', option.text);
        form.appendChild(hidden);
    } else {
        rename.value = option.text;
    }

    disableRenameEdit();
}
*/

function renameBDOption(text) {
    //var option = text.option;
    var bdVarName = text.bdVarName;
    var bdVarNameWithPrefix = valBDPrefix + bdVarName;
    // find suitable option
    var s = document.getElementById('itemDisplayColumns');
    var option;
    for (i=0; i<s.options.length; i++) {
        if (s.options[i].value == bdVarNameWithPrefix) {
            option = s.options[i];
            break;
        }
    }
    if (! option)
        return;

    var newAlias = text.value;
    var bdVarName = option.value.substr(valBDPrefix.length);
    option.text = labelBDPrefix + newAlias;
    option.selected = false;

    var form = option.form;
    var rename = null;
    var inputs = form.getElementsByTagName('input');
    for (var i=0; i<inputs.length; i++) {
        //if (inputs[i].name == option.value) {
        if (inputs[i].name == bdVarName) {
            rename = inputs[i];
        }
    }

    if (rename == null) {
        // Add hidden input
        var hidden = document.createElement('input');
        hidden.setAttribute('type', 'hidden');
        hidden.setAttribute('name', bdVarName); //option.value);
        hidden.setAttribute('value', newAlias); //option.text);
        form.appendChild(hidden);
    } else {
        rename.value = newAlias; //option.text;
    }

	// Synchronize item names in "sort1" and "sort2" column lists
	// after the item has been renamed
    var sortColumnSelector1 = document.getElementById("sort1");
    var sortColumnSelector2 = document.getElementById("sort2");
    // Get unqualified(unprefixed) name of the item
   	var optionValue = getUnqualifiedBDVarNameFromOptionValue(option.value);
	var optionIndex = findOption(sortColumnSelector1, optionValue);
    if (optionIndex != -1) {
		var option1 = sortColumnSelector1.options[optionIndex];
		option1.text = newAlias;
    }
	optionIndex = findOption(sortColumnSelector2, optionValue);
    if (optionIndex != -1) {
		var option1 = sortColumnSelector2.options[optionIndex];
		option1.text = newAlias;
    }

    disableRenameEdit();
}

/*
function selectBusinessData() {
    var options = document.getElementById('bdDisplayColumns').options;
    for (var i=0; i<options.length; i++) {
        var option = options[i];
        option.selected = true;
    }
}
*/

function selectBusinessData() {
    var options = document.getElementById('itemDisplayColumns').options;
    for (var i=0; i<options.length; i++) {
        var option = options[i];
        if (startsWith(option.value, valBDPrefix))
            option.selected = true;
    }
}

function selectedCount(t) {
    var count = 0;
    for (var i=0; i<t.options.length; i++) {
        if (t.options[i].selected) {
            count++;
        }
    }
    return count;
}




/***********************************************************************
 *
 * This code is designed for searching by BusinessData.
 * Some functions can be move into more common script.
 * @author V Melnykov
 *
 ***********************************************************************/


function BusinessDataConstants() {
}
// TODO: replace <input name>, <input value> by values from i18.
BusinessDataConstants.INPUT_VAR_NAME_PROMPT     = BusinessDataConstants_inputName;
BusinessDataConstants.INPUT_VALUE_PROMPT        = BusinessDataConstants_inputValue;
BusinessDataConstants.CONSTRAINT_PANE_ID_PREFIX = "bdConstraintPane";
BusinessDataConstants.VAR_NAME_ID_PREFIX        = "bdVariableName";
BusinessDataConstants.TYPE_ID_PEFIX             = "bdType";
BusinessDataConstants.OPERATOR_ID_PEFIX         = "bdOperator";
//BusinessDataConstants.VALUE_ID_PEFIX            = "bdVariableValue";
BusinessDataConstants.ALIAS_ID_PEFIX            = "bdVariableAlias";
//BusinessDataConstants.BD_IS_ALIAS_ID_PEFIX    = "bdIsAlias";
BusinessDataConstants.PROP_BUSINESS_DATA_PREFIX = "businessData."
BusinessDataConstants.BUSINESS_DATA_COLUMN      = "BusinessDataGeneral"

function logWarn() {
}


/***********************************************************************
 * Encapsulates condition operator.
 ***********************************************************************/
function Operator(name, text) {

  this.name = name;
  this.text = text;
  
  this.toString = function() {
    //return "Operator { name: " + this.name + ", text: " + this.text +  "} ";
    return this.name;
  }
  this.valueOf = function() {
    return this.name;
  }
}


// TODO: add strings from i18
/**
 * Supported operators.
 */
Operator.EQUALS       = new Operator("Equals" ,     displayName_Equals);
Operator.NOT_EQUALS   = new Operator("NotEquals",   displayName_NotEquals);
Operator.CONTAINS     = new Operator("Contains",    displayName_Contains);
//Operator.NOT_CONTAINS = new Operator("NotContains", displayName_NotContains);
Operator.STARTS_WITH  = new Operator("StartsWith",  displayName_StartsWith);
Operator.LESS_THAN    = new Operator("LessThan",    displayName_LessThan);
Operator.GREATER_THAN = new Operator("GreaterThan", displayName_GreaterThan);
//Operator.UNKNOWN    = new Operator("Unknown",     "Unknown");
Operator.OPERATORS = new Array(Operator.EQUALS, Operator.NOT_EQUALS, Operator.CONTAINS,
   Operator.STARTS_WITH, Operator.LESS_THAN, Operator.GREATER_THAN);
Operator.values = function() {
  return Operator.OPERATORS;
}

var __operatorMap = new Object();
function __registerOperator1(op) {
  __operatorMap[op] = op;
  __operatorMap[op.valueOf()] = op;
}
for (var i=0; i<Operator.OPERATORS.length; i++) {
  __registerOperator1(Operator.OPERATORS[i]);
}

Operator.findByName = function(operatorName) {
  var operator = __operatorMap[operatorName];
  if (operator) {
    return operator;
  } else {
   //return Operator.UNKNOWN;
   throw new Error("Operator '" + operatorName + "' is not supported.");
  }
}



/**************************************************************************
 * Encapsulates TW type (to avoid strings hardcoding).
 **************************************************************************/
function TWType(baseTypeName, name) {

  this.baseTypeName = baseTypeName;
  this.name = name ? name : baseTypeName;

  this.toString = function() {
    return this.name;
  }
	  
  this.getBaseTypeName = function() {
    return this.baseTypeName;
  }
	  
  this.getName = function() {
    return this.name;
  }
}

/**
 * Supported types.
 */
TWType.STRING  = new TWType("String");
TWType.INTEGER = new TWType("Integer");
TWType.DECIMAL = new TWType("Decimal");
TWType.DATE    = new TWType("Date");
TWType.TIME    = new TWType("Time");
TWType.BOOLEAN = new TWType("Boolean");
TWType.UNKNOWN = new TWType("Unknown");
TWType.TYPES   = new Array(TWType.STRING, TWType.BOOLEAN, TWType.INTEGER, TWType.DECIMAL, TWType.DATE, TWType.TIME, TWType.UNKNOWN);
TWType.MIN_TYPES = new Array(TWType.STRING, TWType.BOOLEAN, TWType.DECIMAL, TWType.DATE, TWType.TIME, TWType.UNKNOWN);
TWType.values = function() {
  return TWType.TYPES;
}

var __typeMap = new Object();
TWType.registerTWType = function(type) {
  __typeMap[type] = type;
  __typeMap[type.getName()] = type;
}
for (var i=0; i<TWType.TYPES.length; i++) {
  TWType.registerTWType(TWType.TYPES[i]);
}

/**
 * Returns corresponding object.
 * If it doesn't exist, error will be thrown. 
 */
TWType.findByName = function (typeName) {
  var type = __typeMap[typeName];
  if (typeName) {
    return type;
  } else {
   //return TWType.UNKNOWN;
   throw new Error("Type '" + typeName + "' is not supported.");
  }
}

/**
 * Operator list for other types.
 */
var __opeartorsMap = new Object();
function __registerOperatorsFor(type, operators) {
  __opeartorsMap[type] = operators;
  __opeartorsMap[type.valueOf()] = operators;
}
__registerOperatorsFor(TWType.STRING,  new Array(Operator.EQUALS,  Operator.NOT_EQUALS ,
       Operator.STARTS_WITH, Operator.CONTAINS));
__registerOperatorsFor(TWType.UNKNOWN,  getOperatorsFor(TWType.STRING)); // the same operators
__registerOperatorsFor(TWType.BOOLEAN, new Array(Operator.EQUALS,  Operator.NOT_EQUALS ));
__registerOperatorsFor(TWType.INTEGER, new Array(Operator.EQUALS,  Operator.NOT_EQUALS ,
       Operator.LESS_THAN, Operator.GREATER_THAN));
__registerOperatorsFor(TWType.DECIMAL, new Array(Operator.EQUALS,  Operator.NOT_EQUALS ,
       Operator.LESS_THAN, Operator.GREATER_THAN));
__registerOperatorsFor(TWType.DATE,    new Array(Operator.LESS_THAN, Operator.GREATER_THAN));
__registerOperatorsFor(TWType.TIME,    new Array(Operator.LESS_THAN, Operator.GREATER_THAN)); // ??? maybe and Operator.NOT_EQUALS 


/**
 * Returns condition operators array for specific type.
 * If it doesn't exist, error will be thrown.
 */
function getOperatorsFor(type) {
  var res = __opeartorsMap[TWType.findByName(type.getBaseTypeName())];
  if (res) {
    return res;
  }
  throw new Error("Cannot find operators for type '" + type + "'.");
}

/**
 * Class for search business variable (alias).
 * @param alias
 * @param type can be string or TWType,
 *  if it is absent it will be gotten from name
 * (in this case name must contain type suffix)
 */
function BDSearchVariable(alias, type) {

  this.alias = extractBDPureVarName(alias);
  this.type  = type ? type : extractBDTypeFromVarName(alias);

  this.toString = function() {
    return "BDSearchVariable { alias: " + this.alias + ", type: " + this.type + " } ";
  }
  
  this.getTypeQualifiedName = function() {
    return this.alias + "@" + this.type;
  }

  this.getHumanName = function() {
    return this.alias;
  }
}


/**
 * Select specified option in SELECT.
 */
function __selectSelectOptionByIndex(selectObj, index) {
  selectObj = getHtmlElement(selectObj);
  checkHtmlSelect(selectObj);
  selectObj.options[index].selected = true; // to make sure and for multiple selection
  if (!selectObj.multiple) {
    selectObj.selectedIndex = index;
  }
}

/**
 * Select specified option in SELECT.
 */
function __selectSelectOptionByValue(selectObj, value) {
  selectObj = getHtmlElement(selectObj);
  checkHtmlSelect(selectObj);
  for (var i=0; i<selectObj.options.length; i++) {
    var option = selectObj.options[i];
    if (option.value == value) {
      __selectSelectOptionByIndex(selectObj, i);
    }
  }
}

/**
 * Fills SELECT with condition operators for specific type.
 */
function fillOperatorsForType(obj, type, selectItem) {
  var operators = getOperatorsFor(type);
  obj = getHtmlElement(obj);
  checkHtmlSelect(obj);
  obj.options.length = 0; // clear
  for (var i=0; i<operators.length; i++) {
    var op = operators[i];
    obj.options.add(new Option(op.text, op.name));
    if (selectItem && ((selectItem == op) || (selectItem == obj.options[i].value))) {
      __selectSelectOptionByIndex(obj, i);
    }
  }
}

/**
 * Fills SELECT with TW types.
 */
function fillWithTWTypes(obj, selectItem) {
  obj = getHtmlElement(obj);
  checkHtmlSelect(obj);
  obj.options.length = 0; // clear
  //for (var i=0; i<TWType.TYPES.length; i++) {
  for (var i=0; i<TWType.MIN_TYPES.length; i++) {
    var type = TWType.MIN_TYPES[i];
    obj.options.add(new Option(type.toString(), type.getName()));
    if (selectItem && ((selectItem == type) || (selectItem == obj.options[i].value))) {
      __selectSelectOptionByIndex(obj, i);
    }
  }
}

/**
 * Returns value of selected item or undefined object.
 */
function getSingleSelection(obj) {
  obj = getHtmlElement(obj);
  checkHtmlSelect(obj);
  return (obj.selectedIndex != -1) ? obj.options[obj.selectedIndex].value : undefined;
}

/**
 * If the object is not has no this tagName, error will be thrown.
 */
function checkHtmlForTagName(obj, tagName) {
  obj = getHtmlElement(obj);
  if (!obj || !obj.tagName || (obj.tagName.toLowerCase() != tagName.toLowerCase())) {
    throw new Error("Object '" + (obj  ? obj.id : obj) + "' is not <" + tagName +">.");
  }
}

/**
 * If the object is not SELECT, error will be thrown.
 */
function checkHtmlSelect(obj) {
  checkHtmlForTagName(obj, "select");
}

/**
 *
 */
function getHtmlElement(obj) {
  if (typeof(obj) == "string") {
    return document.getElementById(obj);
  }
  return obj;
}

/**
 *
 */
function getHtmlSelectElement(obj) {
  if (typeof(obj) == "string") {
    return document.getElementById(obj);
  }
  checkHtmlSelect(obj);
  return obj;
}

/**
 * Shows/hides HTML element using CSS 'display' style.
 * Other values are used for other HTML elements.
 * If the object doesn't exist, error will be thrown.
 */
function setDisplayVisible(obj, visible) {
  obj = getHtmlElement(obj);
  if (!obj.tagName) {
    throw new Error("Object '" + obj + "' is not HTML tag.");
  }
  switch (obj.tagName) {
    case "DIV":
      obj.style.display = visible ? 'block'  : 'none';
      break;
    case "SPAN":
      obj.style.display = visible ? 'inline' : 'none';
      break;
    case "TR":
      if (document.all) {
        obj.style.display = visible ? 'block'  : 'none';
      } else { // TODO: Opera and IE7 have not been tested yet.
        obj.style.display = visible ? 'table-row' : 'none';
      }
      break;
    default:
      obj.style.display = visible ? 'inline' : 'none';
      break;
  }
}

/**
 * Returns TWType object.
 */
function extractBDTypeFromVarName(name) {
  var index = name.lastIndexOf('@');
  if (index == -1) {
    return TWType.UNKNOWN;
  }
  var type = name.substring(index + 1);
  //try {
    return TWType.findByName(type);
  //} catch (ex) {
  //  // ???
  //  return BusinessDataType.UNKNOWN;
  //}
}
	
// if suffix doesn't match any type, it is not removed
function removeBDTypeFromVarName(name) {
  var index = name.lastIndexOf('@');
  if (index == -1) {
    return name;
  }
  var type = name.substring(index + 1);
  try {
    TWType.findByName(type);
    // if success
    return name.substring(0, index);
  } catch (ex) {
    // ???
    return name;
  }
}


function clearHtmlSelectSelection(obj) {
  obj = getHtmlSelectElement(obj);
  obj.selectedIndex = -1; // for single selection
  for (var i=0; i<obj.options.length; i++) { // for multiple selection
    obj.options[i].selected = false;
  }
}


function setInputValue(obj, value) {
  if (dijit.byId(obj)) {
    var widget = dijit.byId(obj);
    switch(widget.declaredClass){
        case "com.lombardisw.DateTimePicker":
            widget.attr("value", dojo.date.locale.parse(value, {datePattern:"yyyy-MM-dd", timePattern: "HH:mm:ss"}));
            break;
        default:
            throw new Error("Unknown widget type: " + widget.declaredClass);    
    }
    return;
  }
    
  obj = getHtmlElement(obj);
  if (!obj || !obj.tagName) {
    throw new Error("Cannot access to object '" + obj + "'.");
  }
  switch (obj.tagName) {
    case 'SELECT':
      obj.selectedIndex = -1;
      clearHtmlSelectSelection(obj);
      __selectSelectOptionByValue(obj, value);
      break;
    case 'INPUT':
    case 'TEXTAREA':
    case 'BUTTON':
      obj.value = value;
      break;
    default:
      throw new Error("Cannot set value for tag '" + obj.tagName + "'.");
  }
}


// if suffix doesn't match any type, it is not removed
function extractBDPureVarName(qualifiedName) {
  var name = qualifiedName;
  if (startsWith(name, BusinessDataConstants.PROP_BUSINESS_DATA_PREFIX)) {
    name = name.substring(BusinessDataConstants.PROP_BUSINESS_DATA_PREFIX.length);
  }
  return removeBDTypeFromVarName(name);
}

/**
 * Return unqualified Business Data Variable's name from option's value
 * in "displayed(result)" column list.
 *
 * For local BD variables' names we use "BD:" prefix and in this case
 * we have to un-prefix it. If the passed qualified name is not
 * BD variable's name then the name is not modified and is returned
 * unchanged.
 * 
 * @param {String} qualifiedName the column name to be processed
 * @return {String} column name or original value is not BD variable's name.
 * 
 * @see moveColumns2() 
 */
function getUnqualifiedBDVarNameFromOptionValue(qualifiedName) {
  var name = qualifiedName;
  if (startsWith(name, valBDPrefix)) {
    name = name.substring(valBDPrefix.length);
  }
  return name;
}

function addConstraintByIndex(index, column, operator, value) {
  if (startsWith(column, BusinessDataConstants.PROP_BUSINESS_DATA_PREFIX)) {
    addBDConstraintByIndex(index, column, operator, value);
  }
  else {
    if (!column || column == "null") { // if nothing selected
      column = "";
      value = "";
      operator = "";
    }
    addSimpleConstraintByIndex(index, column, operator, value);
  }
}

function addSimpleConstraintByIndex(index, column, operator, value) {
  var columnsID   = "condition" + index + "column";
  var operatorsID = "condition" + index + "operator";
  var valueID     = "condition" + index + "value";
  setInputValue(columnsID, column);
  initializeOperator(getHtmlSelectElement(columnsID), value);
  //setInputValue(operatorsID, extractBDTypeFromVarName(businessColumn));
  //setInputValue(businessColumnsID, businessColumn);
  setInputValue(valueID, value);
}

function addBDConstraintByIndex(index, businessColumn, operator, value) {
  //alert("addBDConstraintByIndex(" + index + ", " + businessColumn + ", " + operator + ", " + value + ")");
  var columnsID = "condition" + index + "column";
  var businessColumnsID = "condition" + index + BusinessDataConstants.ALIAS_ID_PEFIX;
  var operatorsID = "condition" + index + "operator";
  var valueID = "condition" + index + "value";
  setInputValue(columnsID, BusinessDataConstants.BUSINESS_DATA_COLUMN);
  initializeOperator(getHtmlSelectElement(columnsID), value);
  setInputValue(businessColumnsID, businessColumn);
  fillOperatorsForType(operatorsID, extractBDTypeFromVarName(businessColumn), operator);
  setInputValue(operatorsID, operator);
  setInputValue(valueID, value);
}




/*

/ **
 * Finds last visible DataBusiness constraint pane using CSS style 'display'.
 * /
function __findLastVisibleBDConstraintIndex() {
  for (var i=100; i>=0; i--) {
    var obj = document.getElementById(BusinessDataConstants.CONSTRAINT_PANE_ID_PREFIX + i);
    if (obj && obj.style && obj.style.display && (obj.style.display != 'none')) {
      return i;
    }
  }
  return -1;
}

/ **
 * Finds the first invisible DataBusiness constraint pane and shows the one.
 * Returns true if success, false otherwise.
 * /
function addBDConstraint() {
  var lastIndex = __findLastVisibleBDConstraintIndex();
  obj = getHtmlElement(BusinessDataConstants.CONSTRAINT_PANE_ID_PREFIX + (lastIndex + 1));
  if (obj) {
    setDisplayVisible(obj, true);
    resetBDConstraint(lastIndex + 1);
    //setBDConstraintInputsVisibility(lastIndex + 1, true)
  }
  setDisplayVisible(getHtmlElement('removeBDConstraintButton'), true);
  return obj ? true : false;
}

/ **
 *
 * @param visible string or boolean value
 * /
function setBDConstraintInputsVisibility(index, visible) {
  var strVisible = (typeof(visible) == "string") ? visible :
     ( visible ? "visible" : "hidden" );
  getHtmlElement(BusinessDataConstants.VAR_NAME_ID_PREFIX + index).style.visibility = strVisible;
  getHtmlElement(BusinessDataConstants.TYPE_ID_PEFIX + index).style.visibility = strVisible;
  getHtmlElement(BusinessDataConstants.OPERATOR_ID_PEFIX + index).style.visibility = strVisible;
  getHtmlElement(BusinessDataConstants.VALUE_ID_PEFIX + index).style.visibility = strVisible;
}

function resetBDConstraint(index) {
    getHtmlElement(BusinessDataConstants.VAR_NAME_ID_PREFIX + index).value = BusinessDataConstants.INPUT_VAR_NAME_PROMPT;
	setInputValue(getHtmlElement(BusinessDataConstants.TYPE_ID_PEFIX + index), TWType.STRING);
	fillOperatorsForType(getHtmlElement(BusinessDataConstants.OPERATOR_ID_PEFIX + index), TWType.STRING, Operator.EQUALS);
	getHtmlElement(BusinessDataConstants.VALUE_ID_PEFIX + index).value = BusinessDataConstants.INPUT_VALUE_PROMPT;
}



function addBDConstraintForQualifiedVariable(varName, operator, value) {
  return addBDConstraintForVriable(extractBDPureVarName(varName),
        extractBDTypeFromVarName(vraType), operator, value);
}

function addBDConstraintForVariable(varName, varType, operator, value) {
  if (!addBDConstraint()) {
    logWarn("Cannot create new BDConstraint, last visible index is "
      + __findLastVisibleBDConstraintIndex() + ".");
    return false;
  }
  var lastIndex = __findLastVisibleBDConstraintIndex();
  var varNameField  = getHtmlElement(BusinessDataConstants.VAR_NAME_ID_PREFIX + lastIndex);
  var typeField  = getHtmlElement(BusinessDataConstants.TYPE_ID_PEFIX + lastIndex);
  var operatorField = getHtmlElement(BusinessDataConstants.OPERATOR_ID_PEFIX + lastIndex);
  var valueField    = getHtmlElement(BusinessDataConstants.VALUE_ID_PEFIX + lastIndex);
  //operator = (typeof(operator) == 'string') ? Operator.findByName(operator) : operator;
  
  setInputValue(typeField, varType);
  varNameField.value = varName;
  fillOperatorsForType(operatorField, varType, operator);
  //selectOption(operatorField, operator);
  //operatorField.value = varName;
  valueField.value = value;
  return true;
}


/ **
 * Finds the last visible DataBusiness constraint pane and hides the one.
 * Returns true if success, false otherwise.
 * /
function removeBDConstraint() {
  var lastIndex = __findLastVisibleBDConstraintIndex();
  if (lastIndex != -1) {
    setDisplayVisible(getHtmlElement(BusinessDataConstants.CONSTRAINT_PANE_ID_PREFIX + lastIndex), false);
    //setBDConstraintInputsVisibility(lastIndex, false)
    resetBDConstraint(lastIndex);
  }
  setDisplayVisible(getHtmlElement('removeBDConstraintButton'), __findLastVisibleBDConstraintIndex() != -1 );
  return lastIndex != -1;
}


*/

/**
 * Validate whether there is any BPD exposed, if no any BPD exposed, return false to break the form submit
 */
function validateExposedBPD(form) {
  var visibleConditions = [];
  dojo.query("div.condition", form).forEach(
    function(div) {
	  if (dojo.style(div).display == 'block' && div.id.match('^condition\\d+'))
	    visibleConditions.push(div);
    }
  );
  for (var i in visibleConditions) {
	var selectName = dojo.byId(visibleConditions[i].id + "column");
	var selectValue = dojo.byId(visibleConditions[i].id + "value");
	if (selectName.value == 'bpdName') {
	  if (!selectValue.value) {
	    alert(problemNoExposedBPD_Alert);
	    return false;
	  }
	}
  }
  return true;
}
