/*
 * Debug.js
 *
 * Some very, very simple debugging stuff - definitely not for production code.
 *
 * Copyright - Lombardi Software 2005
 * 
 * @version 0.1 - 03.09.2005 
 * @author Hugh Leather (hughleat@hotmail.com) 
 */

/**
 * A simple class containing some very rudimentary debugging capabilities.
 */
function Debug() {
}

/**
 * Debugging level.  Calls to levels below this will do nothing
 */
Debug.debugLevel = 0;

/**
 * Get the properties of an object as a string
 *
 * @param x an object to get the properties of
 * @return a string with all the properties in it
 */
Debug.getProps = function( x ) {
	if( x == null ) return "<null object>";
	var str = "";
	for( i in x ) {
		if( x[ i ] != null && typeof( x[ i ] ) != 'function' )
			str += i + "=" + x[ i ] + "\n";
	}
	return str;
}	

/**
 * Trace.  
 *
 * @param msg the message to trace
 * @param level if above or equal to Debug.debugLevel, will alert the string;
 * either way it will store it later for display trace.  If level is undefined,
 * then it assumed to be non alerting.
 */
Debug.trace = function( msg, level ) {
	if( level != null && level >= Debug.debugLevel ) alert( msg );
	if( Debug._trace == null ) Debug._trace = "";
	Debug._trace += msg + "\n";
}

/**
 * Display the traces gathered by previous calls to Debug.trace and clear the
 * saved trace log.
 *
 * @param clear whether to clear the log
 * @param level if above or equal to Debug.debugLevel, will alert the string;
 * If level is undefined, then it assumed to be alerting.
 */
Debug.displayTrace = function( clear, level ) {
	if( level == null || level >= Debug.debugLevel ) alert( Debug._trace );
	if( clear ) Debug._trace = null;
}

