
// Used to keep track of which process instance and tasks have been selected.
var instances = {};

var taskids = {};

function doFavorite(id) {
    if (id && id != -1) {
        togglePopup('new');
        window.open('/teamworks/process.lsw?zObject=Favorite&zActivity=Execute&zPost=1&zFromPage=tm_toolbar.lsw&zFavId=' + id,'_blank','height=560,width=650,scrollbars=yes,resizable');
    }
}

function doFavoriteFromProject(id,ref){
	if (id && id != -1) {    			
        window.open('/teamworks/process.lsw?zWorkflowState=5&zObject=Favorite&zActivity=Execute&zPost=1&zFromPage=tm_toolbar.lsw&zProcessRef=' + ref +'&zFavId=' + id,'_blank','height=560,width=650,scrollbars=yes,resizable');
    }
} 

function doStartEvent(instanceId, flowObjectId) {
    dojo.xhrGet({
        url: 'inject?bpdInstanceId='+instanceId+'&flowObjId='+flowObjectId,
        handleAs: "xml",
        load: dojo.hitch(this, function(o) {
            var token = o.getElementsByTagName("TOKEN")[0]; // there should just one token
            if(token.getElementsByTagName("TASKID")[0] != null) {
                var task = token.getElementsByTagName("TASKID")[0]; // get first one, other ignore
                var taskid = task.text||task.textContent; // just IE (for Firefox should be task.textContent)
                performPopupActionSingleWindow('teamworksruntask'+taskid, '/teamworks/process.lsw?zWorkflowState=1', 'zTaskId='+taskid, 'height=600,width=720,scrollbars=yes,resizable=yes');
            } else {
                window.location.reload();
            }
        }),
        error: dojo.hitch(this, function(o) {
            alert(problemStartEvent_Alert);
        })
    });
}

function togglePopup(what) {
	var item = document.getElementById(what);
	if (item) {
		if (item.style.display != "none" && item.style.display != "") {
			item.style.display = "none";
		} else {
			item.style.display = "block";
		}
	}
}

function onSelectionChange() {
    var url = 'getButtonStates.do?data=1'
    if ((typeof instances != "undefined") && (instances != null)) {
        for (i in instances) {
            url += '&id=' + i;
        }
    }
    if ((typeof taskids != "undefined") && (taskids != null)) {
        for (i in taskids) {
            url += '&tid=' + i;
        }
    }

    /* Calling the ajax function, which is in main.js */
    ajax(window, url, updateButtonStates);
}

function updateButtonStates() {
    if (window.req != null && window.req.readyState == 4) {
        if (window.req.status == 200) {
            var doc = window.req.responseXML;
            // This used to use doc.firstChild.childNodes but that didn't work in IE
            var children = doc.getElementsByTagName("BUTTONSTATES")[0].childNodes;
            for (var i = 0; i < children.length; ++i) {
                var id = children[i].nodeName;
                var button = document.getElementById(id);
                if (button) {
                    updateButton(document.getElementById(id), children[i].firstChild.data=="true");
                }
            }
        } else {
            alert(problemRetrievingXMLData_Alert + "\n" + window.req.statusText);
        }
    }
}

// Call when an instance is checked or unchecked in the ui
function updateInstanceChecked(id, isChecked) {
    if ((typeof instances != "undefined") && (instances != null)) {
        _updateInstanceOrTaskChecked(instances, id, isChecked);
    }
}

// Call when an task is checked or unchecked in the ui
function updateTaskChecked(id, isChecked) {
    if ((typeof taskids != "undefined") && (taskids != null)) {
        _updateInstanceOrTaskChecked(taskids, id, isChecked);
    }
}

// do not call from ui - used only by updateInstanceChecked and updateTaskChecked
function _updateInstanceOrTaskChecked(idList, id, isChecked) {
    if (id >= 0) {
        if (isChecked) {
        	if (idList[id] == null) {
        		idList[id] = 0;
        	}
        	idList[id]++;
        } else {
        	idList[id]--;
        	if (idList[id] <= 0) {
            	delete idList[id];
        	}
        }
    }
}

function updateButton(b, enable) {

    /* This causes toolbar to grow and not work for small screens like 1024x768
       It isn't needed either since the <a> tag is set to disabled which grays out the text. 
    if (enable) {
        b.className = "button";
    } else {
        b.className = "button-disabled";
    }*/
    var images = b.getElementsByTagName("img");
    for (var i=0; i<images.length; i++) {
        var image = images[i];
        var src = image.src;
        if (enable) {
            newsrc = src.replace(/disabled/, "enabled");
        } else {
            newsrc = src.replace(/enabled/, "disabled");
        }
        image.src = newsrc;
    }
    var links = b.getElementsByTagName("a");
    for (var i=0; i<links.length; i++) {
        var link = links[i];
        var href = link.href;
        if (enable) {
            link.disabled = false;
            if (link.oldhref) {
                link.href = link.oldhref;
                link.oldhref = null;
                link.onclick = function() {return true;};
            }
        } else {
            link.disabled = true;
            if ((typeof link.oldhref == 'undefined') || (link.oldhref == null)) {
                link.oldhref = link.href;
                link.removeAttribute('href');
                link.onclick = function() {return false;};
            }
        }
        link.enabled = enable;
    }
}

function performPopupAction(url, idString, windowParams) {
    if (url.indexOf('?') > -1) {
        url += '&';
    } else {
        url += '?';
    }
    if (typeof windowParams == "undefined") {
        windowParams = "height=420,width=340,scrollbars=no,resizable=yes";
    }
    window.open(url + idString, '_blank', windowParams).focus();
}

function performPopupActionWithWarning(url, idString, windowParams, warning) {
    if(confirm(warning))
        performPopupAction(url, idString, windowParams);
    
}

function performPopupActionSingleWindow(windowName, url, idString, windowParams) {
    if (url.indexOf('?') > -1) {
        url += '&';
    } else {
        url += '?';
    }
    if (typeof windowParams == "undefined") {
        windowParams = "height=380,width=340,scrollbars=no,resizable=no";
    }
    window.open(url + idString, windowName, windowParams).focus();
}

function performPopupActionSingleWindowAndDisable(button, windowName, url, idString, windowParams) {
    if (button.disabled) {
        return;
    }
    button.disabled=true;
    if (url.indexOf('?') > -1) {
        url += '&';
    } else {
        url += '?';
    }
    if (typeof windowParams == "undefined") {
        windowParams = "height=380,width=340,scrollbars=no,resizable=no";
    }
    window.open(url + idString, windowName, windowParams).focus();

    setTimeout(function () { button.disabled=false }, 1000);
}

function performPopupActionWithWarningSingleWindow(windowName, url, idString, windowParams, warning) {
    if(confirm(warning))
        performPopupActionSingleWindow(windowName, url, idString, windowParams);
    
}

function performNonPopupAction(prefix, url, idString) {
    url = prefix + '/' + url;
	performNonPopupActionWithoutPrefix(url, idString);
}

function performNonPopupActionWithoutPrefix(pUrl, idString) {
    url = pUrl;
    if (url.indexOf('?') > -1) {
        url += '&';
    } else {
        url += '?';
    }
    window.location = url + idString;
}

function makeInstanceIdString(paramName) {
    return _makeIdString(instances, paramName);
}

function makeTaskIdString() {
    return _makeIdString(taskids, "id");
}

function _makeIdString(idList, paramName) {
    var s = "";
    if (paramName == null || paramName == undefined) {
    	paramName = "id";
    }
    for (var i in idList) {
        if (s != '') {
            s += "&";
        }
        s += paramName + "=" + i;
    }
    return s;
}

function toggleNewPopup()
{
    var item = document.getElementById('new');
    if(item)
    {
        if (item.style.display != "none" && item.style.display != "") {
            item.style.display = "none";
        } else {
            item.style.display = "block";
        }
    }
} 
// bondy.onclick() handler
function closeNewPopup() {
    var item = document.getElementById('new');
    if(item)
    {
        if (item.style.display != "none" && item.style.display != "") {
            item.style.display = "none";
        } 
    }	
 }
